]> asedeno.scripts.mit.edu Git - git.git/blob - t/test-lib.sh
test-lib: Work around missing sum on Windows
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10         # do not redirect again
11         ;;
12 *' --tee '*|*' --va'*)
13         mkdir -p test-results
14         BASE=test-results/$(basename "$0" .sh)
15         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16          echo $? > $BASE.exit) | tee $BASE.out
17         test "$(cat $BASE.exit)" = 0
18         exit
19         ;;
20 esac
21
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
24
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 VISUAL=:
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 GIT_MERGE_VERBOSITY=5
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61 export EDITOR VISUAL
62 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
63
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
66 unset CDPATH
67
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69         1|2|true)
70                 echo "* warning: Some tests will not work if GIT_TRACE" \
71                         "is set as to trace on STDERR ! *"
72                 echo "* warning: Please set GIT_TRACE to something" \
73                         "other than 1, 2 or true ! *"
74                 ;;
75 esac
76
77 # Each test should start with something like this, after copyright notices:
78 #
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
81 # '
82 # . ./test-lib.sh
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84                 TERM=$ORIGINAL_TERM &&
85                 export TERM &&
86                 [ -t 1 ] &&
87                 tput bold >/dev/null 2>&1 &&
88                 tput setaf 1 >/dev/null 2>&1 &&
89                 tput sgr0 >/dev/null 2>&1
90         ) &&
91         color=t
92
93 while test "$#" -ne 0
94 do
95         case "$1" in
96         -d|--d|--de|--deb|--debu|--debug)
97                 debug=t; shift ;;
98         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
99                 immediate=t; shift ;;
100         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
101                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
102         -h|--h|--he|--hel|--help)
103                 help=t; shift ;;
104         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
105                 verbose=t; shift ;;
106         -q|--q|--qu|--qui|--quie|--quiet)
107                 quiet=t; shift ;;
108         --no-color)
109                 color=; shift ;;
110         --no-python)
111                 # noop now...
112                 shift ;;
113         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
114                 valgrind=t; verbose=t; shift ;;
115         --tee)
116                 shift ;; # was handled already
117         *)
118                 break ;;
119         esac
120 done
121
122 if test -n "$color"; then
123         say_color () {
124                 (
125                 TERM=$ORIGINAL_TERM
126                 export TERM
127                 case "$1" in
128                         error) tput bold; tput setaf 1;; # bold red
129                         skip)  tput bold; tput setaf 2;; # bold green
130                         pass)  tput setaf 2;;            # green
131                         info)  tput setaf 3;;            # brown
132                         *) test -n "$quiet" && return;;
133                 esac
134                 shift
135                 printf "* %s" "$*"
136                 tput sgr0
137                 echo
138                 )
139         }
140 else
141         say_color() {
142                 test -z "$1" && test -n "$quiet" && return
143                 shift
144                 echo "* $*"
145         }
146 fi
147
148 error () {
149         say_color error "error: $*"
150         trap - EXIT
151         exit 1
152 }
153
154 say () {
155         say_color info "$*"
156 }
157
158 test "${test_description}" != "" ||
159 error "Test script did not set test_description."
160
161 if test "$help" = "t"
162 then
163         echo "$test_description"
164         exit 0
165 fi
166
167 exec 5>&1
168 if test "$verbose" = "t"
169 then
170         exec 4>&2 3>&1
171 else
172         exec 4>/dev/null 3>/dev/null
173 fi
174
175 test_failure=0
176 test_count=0
177 test_fixed=0
178 test_broken=0
179 test_success=0
180
181 die () {
182         echo >&5 "FATAL: Unexpected exit with code $?"
183         exit 1
184 }
185
186 trap 'die' EXIT
187
188 # The semantics of the editor variables are that of invoking
189 # sh -c "$EDITOR \"$@\"" files ...
190 #
191 # If our trash directory contains shell metacharacters, they will be
192 # interpreted if we just set $EDITOR directly, so do a little dance with
193 # environment variables to work around this.
194 #
195 # In particular, quoting isn't enough, as the path may contain the same quote
196 # that we're using.
197 test_set_editor () {
198         FAKE_EDITOR="$1"
199         export FAKE_EDITOR
200         VISUAL='"$FAKE_EDITOR"'
201         export VISUAL
202 }
203
204 test_tick () {
205         if test -z "${test_tick+set}"
206         then
207                 test_tick=1112911993
208         else
209                 test_tick=$(($test_tick + 60))
210         fi
211         GIT_COMMITTER_DATE="$test_tick -0700"
212         GIT_AUTHOR_DATE="$test_tick -0700"
213         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
214 }
215
216 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
217 #
218 # This will commit a file with the given contents and the given commit
219 # message.  It will also add a tag with <message> as name.
220 #
221 # Both <file> and <contents> default to <message>.
222
223 test_commit () {
224         file=${2:-"$1.t"}
225         echo "${3-$1}" > "$file" &&
226         git add "$file" &&
227         test_tick &&
228         git commit -m "$1" &&
229         git tag "$1"
230 }
231
232 # Call test_merge with the arguments "<message> <commit>", where <commit>
233 # can be a tag pointing to the commit-to-merge.
234
235 test_merge () {
236         test_tick &&
237         git merge -m "$1" "$2" &&
238         git tag "$1"
239 }
240
241 # This function helps systems where core.filemode=false is set.
242 # Use it instead of plain 'chmod +x' to set or unset the executable bit
243 # of a file in the working directory and add it to the index.
244
245 test_chmod () {
246         chmod "$@" &&
247         git update-index --add "--chmod=$@"
248 }
249
250 # You are not expected to call test_ok_ and test_failure_ directly, use
251 # the text_expect_* functions instead.
252
253 test_ok_ () {
254         test_success=$(($test_success + 1))
255         say_color "" "  ok $test_count: $@"
256 }
257
258 test_failure_ () {
259         test_failure=$(($test_failure + 1))
260         say_color error "FAIL $test_count: $1"
261         shift
262         echo "$@" | sed -e 's/^/        /'
263         test "$immediate" = "" || { trap - EXIT; exit 1; }
264 }
265
266 test_known_broken_ok_ () {
267         test_fixed=$(($test_fixed+1))
268         say_color "" "  FIXED $test_count: $@"
269 }
270
271 test_known_broken_failure_ () {
272         test_broken=$(($test_broken+1))
273         say_color skip "  still broken $test_count: $@"
274 }
275
276 test_debug () {
277         test "$debug" = "" || eval "$1"
278 }
279
280 test_run_ () {
281         eval >&3 2>&4 "$1"
282         eval_ret="$?"
283         return 0
284 }
285
286 test_skip () {
287         test_count=$(($test_count+1))
288         to_skip=
289         for skp in $GIT_SKIP_TESTS
290         do
291                 case $this_test.$test_count in
292                 $skp)
293                         to_skip=t
294                 esac
295         done
296         case "$to_skip" in
297         t)
298                 say_color skip >&3 "skipping test: $@"
299                 say_color skip "skip $test_count: $1"
300                 : true
301                 ;;
302         *)
303                 false
304                 ;;
305         esac
306 }
307
308 test_expect_failure () {
309         test "$#" = 2 ||
310         error "bug in the test script: not 2 parameters to test-expect-failure"
311         if ! test_skip "$@"
312         then
313                 say >&3 "checking known breakage: $2"
314                 test_run_ "$2"
315                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
316                 then
317                         test_known_broken_ok_ "$1"
318                 else
319                     test_known_broken_failure_ "$1"
320                 fi
321         fi
322         echo >&3 ""
323 }
324
325 test_expect_success () {
326         test "$#" = 2 ||
327         error "bug in the test script: not 2 parameters to test-expect-success"
328         if ! test_skip "$@"
329         then
330                 say >&3 "expecting success: $2"
331                 test_run_ "$2"
332                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
333                 then
334                         test_ok_ "$1"
335                 else
336                         test_failure_ "$@"
337                 fi
338         fi
339         echo >&3 ""
340 }
341
342 test_expect_code () {
343         test "$#" = 3 ||
344         error "bug in the test script: not 3 parameters to test-expect-code"
345         if ! test_skip "$@"
346         then
347                 say >&3 "expecting exit code $1: $3"
348                 test_run_ "$3"
349                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
350                 then
351                         test_ok_ "$2"
352                 else
353                         test_failure_ "$@"
354                 fi
355         fi
356         echo >&3 ""
357 }
358
359 # test_external runs external test scripts that provide continuous
360 # test output about their progress, and succeeds/fails on
361 # zero/non-zero exit code.  It outputs the test output on stdout even
362 # in non-verbose mode, and announces the external script with "* run
363 # <n>: ..." before running it.  When providing relative paths, keep in
364 # mind that all scripts run in "trash directory".
365 # Usage: test_external description command arguments...
366 # Example: test_external 'Perl API' perl ../path/to/test.pl
367 test_external () {
368         test "$#" -eq 3 ||
369         error >&5 "bug in the test script: not 3 parameters to test_external"
370         descr="$1"
371         shift
372         if ! test_skip "$descr" "$@"
373         then
374                 # Announce the script to reduce confusion about the
375                 # test output that follows.
376                 say_color "" " run $test_count: $descr ($*)"
377                 # Run command; redirect its stderr to &4 as in
378                 # test_run_, but keep its stdout on our stdout even in
379                 # non-verbose mode.
380                 "$@" 2>&4
381                 if [ "$?" = 0 ]
382                 then
383                         test_ok_ "$descr"
384                 else
385                         test_failure_ "$descr" "$@"
386                 fi
387         fi
388 }
389
390 # Like test_external, but in addition tests that the command generated
391 # no output on stderr.
392 test_external_without_stderr () {
393         # The temporary file has no (and must have no) security
394         # implications.
395         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
396         stderr="$tmp/git-external-stderr.$$.tmp"
397         test_external "$@" 4> "$stderr"
398         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
399         descr="no stderr: $1"
400         shift
401         say >&3 "expecting no stderr from previous command"
402         if [ ! -s "$stderr" ]; then
403                 rm "$stderr"
404                 test_ok_ "$descr"
405         else
406                 if [ "$verbose" = t ]; then
407                         output=`echo; echo Stderr is:; cat "$stderr"`
408                 else
409                         output=
410                 fi
411                 # rm first in case test_failure exits.
412                 rm "$stderr"
413                 test_failure_ "$descr" "$@" "$output"
414         fi
415 }
416
417 # This is not among top-level (test_expect_success | test_expect_failure)
418 # but is a prefix that can be used in the test script, like:
419 #
420 #       test_expect_success 'complain and die' '
421 #           do something &&
422 #           do something else &&
423 #           test_must_fail git checkout ../outerspace
424 #       '
425 #
426 # Writing this as "! git checkout ../outerspace" is wrong, because
427 # the failure could be due to a segv.  We want a controlled failure.
428
429 test_must_fail () {
430         "$@"
431         test $? -gt 0 -a $? -le 129 -o $? -gt 192
432 }
433
434 # test_cmp is a helper function to compare actual and expected output.
435 # You can use it like:
436 #
437 #       test_expect_success 'foo works' '
438 #               echo expected >expected &&
439 #               foo >actual &&
440 #               test_cmp expected actual
441 #       '
442 #
443 # This could be written as either "cmp" or "diff -u", but:
444 # - cmp's output is not nearly as easy to read as diff -u
445 # - not all diff versions understand "-u"
446
447 test_cmp() {
448         $GIT_TEST_CMP "$@"
449 }
450
451 # Most tests can use the created repository, but some may need to create more.
452 # Usage: test_create_repo <directory>
453 test_create_repo () {
454         test "$#" = 1 ||
455         error "bug in the test script: not 1 parameter to test-create-repo"
456         owd=`pwd`
457         repo="$1"
458         mkdir -p "$repo"
459         cd "$repo" || error "Cannot setup test environment"
460         "$GIT_EXEC_PATH/git" init "--template=$owd/../templates/blt/" >&3 2>&4 ||
461         error "cannot run git init -- have you built things yet?"
462         mv .git/hooks .git/hooks-disabled
463         cd "$owd"
464 }
465
466 test_done () {
467         trap - EXIT
468         test_results_dir="$TEST_DIRECTORY/test-results"
469         mkdir -p "$test_results_dir"
470         test_results_path="$test_results_dir/${0%.sh}-$$"
471
472         echo "total $test_count" >> $test_results_path
473         echo "success $test_success" >> $test_results_path
474         echo "fixed $test_fixed" >> $test_results_path
475         echo "broken $test_broken" >> $test_results_path
476         echo "failed $test_failure" >> $test_results_path
477         echo "" >> $test_results_path
478
479         if test "$test_fixed" != 0
480         then
481                 say_color pass "fixed $test_fixed known breakage(s)"
482         fi
483         if test "$test_broken" != 0
484         then
485                 say_color error "still have $test_broken known breakage(s)"
486                 msg="remaining $(($test_count-$test_broken)) test(s)"
487         else
488                 msg="$test_count test(s)"
489         fi
490         case "$test_failure" in
491         0)
492                 # We could:
493                 # cd .. && rm -fr 'trash directory'
494                 # but that means we forbid any tests that use their own
495                 # subdirectory from calling test_done without coming back
496                 # to where they started from.
497                 # The Makefile provided will clean this test area so
498                 # we will leave things as they are.
499
500                 say_color pass "passed all $msg"
501
502                 test -d "$remove_trash" &&
503                 cd "$(dirname "$remove_trash")" &&
504                 rm -rf "$(basename "$remove_trash")"
505
506                 exit 0 ;;
507
508         *)
509                 say_color error "failed $test_failure among $msg"
510                 exit 1 ;;
511
512         esac
513 }
514
515 # Test the binaries we have just built.  The tests are kept in
516 # t/ subdirectory and are run in 'trash directory' subdirectory.
517 TEST_DIRECTORY=$(pwd)
518 if test -z "$valgrind"
519 then
520         PATH=$TEST_DIRECTORY/..:$PATH
521         GIT_EXEC_PATH=$TEST_DIRECTORY/..
522 else
523         make_symlink () {
524                 test -h "$2" &&
525                 test "$1" = "$(readlink "$2")" || {
526                         # be super paranoid
527                         if mkdir "$2".lock
528                         then
529                                 rm -f "$2" &&
530                                 ln -s "$1" "$2" &&
531                                 rm -r "$2".lock
532                         else
533                                 while test -d "$2".lock
534                                 do
535                                         say "Waiting for lock on $2."
536                                         sleep 1
537                                 done
538                         fi
539                 }
540         }
541
542         make_valgrind_symlink () {
543                 # handle only executables
544                 test -x "$1" || return
545
546                 base=$(basename "$1")
547                 symlink_target=$TEST_DIRECTORY/../$base
548                 # do not override scripts
549                 if test -x "$symlink_target" &&
550                     test ! -d "$symlink_target" &&
551                     test "#!" != "$(head -c 2 < "$symlink_target")"
552                 then
553                         symlink_target=../valgrind.sh
554                 fi
555                 case "$base" in
556                 *.sh|*.perl)
557                         symlink_target=../unprocessed-script
558                 esac
559                 # create the link, or replace it if it is out of date
560                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
561         }
562
563         # override all git executables in TEST_DIRECTORY/..
564         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
565         mkdir -p "$GIT_VALGRIND"/bin
566         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
567         do
568                 make_valgrind_symlink $file
569         done
570         OLDIFS=$IFS
571         IFS=:
572         for path in $PATH
573         do
574                 ls "$path"/git-* 2> /dev/null |
575                 while read file
576                 do
577                         make_valgrind_symlink "$file"
578                 done
579         done
580         IFS=$OLDIFS
581         PATH=$GIT_VALGRIND/bin:$PATH
582         GIT_EXEC_PATH=$GIT_VALGRIND/bin
583         export GIT_VALGRIND
584 fi
585 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
586 unset GIT_CONFIG
587 GIT_CONFIG_NOSYSTEM=1
588 GIT_CONFIG_NOGLOBAL=1
589 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
590
591 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
592 export GITPERLLIB
593 test -d ../templates/blt || {
594         error "You haven't built things yet, have you?"
595 }
596
597 if ! test -x ../test-chmtime; then
598         echo >&2 'You need to build test-chmtime:'
599         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
600         exit 1
601 fi
602
603 . ../GIT-BUILD-OPTIONS
604
605 # Test repository
606 test="trash directory.$(basename "$0" .sh)"
607 test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
608 rm -fr "$test" || {
609         trap - EXIT
610         echo >&5 "FATAL: Cannot prepare test area"
611         exit 1
612 }
613
614 test_create_repo "$test"
615 # Use -P to resolve symlinks in our working directory so that the cwd
616 # in subprocesses like git equals our $PWD (for pathname comparisons).
617 cd -P "$test" || exit 1
618
619 this_test=${0##*/}
620 this_test=${this_test%%-*}
621 for skp in $GIT_SKIP_TESTS
622 do
623         to_skip=
624         for skp in $GIT_SKIP_TESTS
625         do
626                 case "$this_test" in
627                 $skp)
628                         to_skip=t
629                 esac
630         done
631         case "$to_skip" in
632         t)
633                 say_color skip >&3 "skipping test $this_test altogether"
634                 say_color skip "skip all tests in $this_test"
635                 test_done
636         esac
637 done
638
639 # Fix some commands on Windows
640 case $(uname -s) in
641 *MINGW*)
642         # Windows has its own (incompatible) sort and find
643         sort () {
644                 /usr/bin/sort "$@"
645         }
646         find () {
647                 /usr/bin/find "$@"
648         }
649         sum () {
650                 md5sum "$@"
651         }
652         ;;
653 esac